您的位置:首页 > 其它

LeetCode Bulls and Cows

2015-11-04 00:13 295 查看
题目:

You are playing the following Bulls and Cows game with your friend:
You write a 4-digit secret number and ask your friend to guess it. Each time your friend guesses a number, you give a hint. The hint tells your friend how many digits are in the correct positions (called "bulls") and how many digits are in the wrong positions
(called "cows"). Your friend will use those hints to find out the secret number.

For example:
Secret number:  "1807"
Friend's guess: "7810"

Hint: 
1
 bull
and 
3
 cows.
(The bull is 
8
,
the cows are 
0
1
 and 
7
.)

Write a function to return a hint according to the secret number and friend's guess, use 
A
 to
indicate the bulls and 
B
 to indicate the cows. In the above example, your function should return 
"1A3B"
.

Please note that both secret number and friend's guess may contain duplicate digits, for example:
Secret number:  "1123"
Friend's guess: "0111"

In this case, the 1st 
1
 in
friend's guess is a bull, the 2nd or 3rd 
1
 is
a cow, and your function should return 
"1A1B"
.

You may assume that the secret number and your friend's guess only contain digits, and their lengths are always equal.

题意:

LZ一开始在理解猜数字游戏时,出现了一些误解的地方,尤其是关于有猜的重复数字出现的时候。其实A是关于在正确的位置上的正确数字,而B表示的是猜的数字对,但是位置不对,如果出现重复的数字,那么只算一次。所以首先是计算在Secret数字中每个数字出现的个数,然后再用guess在减去secret数字中的已经出现的数字,得到的猜错的数字,然后用总的数字长度去减这个值,得到的就是猜对的数字,包括位置对和位置不对的。然后就是再一一的去做一次循环,得到位置对的数字的个数,然后用刚才得到的数字对但是位置不对的数字去减位置对的数字,得到就是B的格式。

public class Solution
{
public String getHint(String secret,String guess)
{
HashMap<Character,Integer> hm = new HashMap<Character,Integer>();
for(int i = 0; i < secret.length(); i++)
{
if(! hm.containsKey(secret.charAt(i)))
{
hm.put(secret.charAt(i), 1);
}
else
hm.put(secret.charAt(i), hm.get(secret.charAt(i)) + 1);
}
for(int i = 0; i < guess.length(); i++)
{
if(hm.containsKey(guess.charAt(i)) && hm.get(guess.charAt(i)) > 0)
{
hm.put(guess.charAt(i),hm.get(guess.charAt(i)) - 1);
}
} //这是看有几个猜对了,但是不管位置
int tmp = 0;
for(Integer i : hm.values())
{
tmp += i;
} //返回所有未出现的次数
int sum = secret.length() - tmp;
int numA = 0;
for(int i = 0; i < secret.length(); i++)
{
if(secret.charAt(i) == guess.charAt(i))
numA++;
}
int numB = sum - numA;
return "" + numA + "A" + numB + "B";
}
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: